#!/bin/bash

cd /etc

# Napraviti backup konfiguracijskog direktorija. 
cp -rfp bacula bacula-bck

cd bacula

# Izdvojiti CSR iz bacula-fd.pem.
openssl x509 -x509toreq -in bacula-fd.pem -out bacula-fd.csr -signkey bacula-fd.pem
# Izdvojiti privatni ključ iz bacula-fd.pem.
openssl rsa -in bacula-fd.pem -out bacula-fd.key

# Napravi v3 ext datoteku
cat > x509v3_ext <<EOF
basicConstraints=CA:FALSE 
subjectKeyIdentifier=hash
EOF

# Napraviti novi certifikat na 5 godina
openssl x509 -req -days 1825 -in bacula-fd.csr -extfile x509v3_ext -out bacula-fd.crt.new -signkey bacula-fd.key

# Spojiti novi certifikat i stari privatni ključ u obnovljenu pem datoteku.
cat bacula-fd.crt.new bacula-fd.key > bacula-fd.pem.new

mv bacula-fd.pem bacula-fd.pem.old
mv bacula-fd.pem.new bacula-fd.pem
chgrp -f bacula bacula-fd.pem && chmod -f 640 bacula-fd.pem

# mali cleanup
rm bacula-fd.csr bacula-fd.key x509v3_ext

# restart bacula-fd servis
service bacula-fd restart

echo "Poslati tekst dolje na sysbackup@carnet.hr i ime poslužitelja na kojem je obnovljen certifikat"
sed -n '/BEGIN CERTIFICATE/,/END CERTIFICATE/p' /etc/bacula/bacula-fd.pem
